"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const Separator = ({ backgroundColor = '#FFF', tintColor = '#C8C7CC', isHidden = false, insetLeft = 15, insetRight = 0, withSafeAreaView = react_native_1.Platform.OS === 'ios'
    ? parseInt(`${react_native_1.Platform.Version}`, 10) <= 10
        ? false
        : true
    : true, }) => {
    const localStyles = {
        separator: [styles.separator, { backgroundColor: backgroundColor }],
        separatorInner: [
            styles.separatorInner,
            {
                backgroundColor: isHidden ? 'transparent' : tintColor,
                marginLeft: insetLeft,
                marginRight: insetRight,
            },
        ],
    };
    if (withSafeAreaView) {
        return (<react_native_1.SafeAreaView style={localStyles.separator}>
        <react_native_1.View style={localStyles.separatorInner}/>
      </react_native_1.SafeAreaView>);
    }
    return (<react_native_1.View style={localStyles.separator}>
      <react_native_1.View style={localStyles.separatorInner}/>
    </react_native_1.View>);
};
const styles = react_native_1.StyleSheet.create({
    separator: {},
    separatorInner: {
        height: react_native_1.StyleSheet.hairlineWidth,
    },
});
exports.default = Separator;
//# sourceMappingURL=Separator.js.map