import React from 'react';
import { Platform, SafeAreaView, StyleSheet, View, } from 'react-native';
const Separator = ({ backgroundColor = '#FFF', tintColor = '#C8C7CC', isHidden = false, insetLeft = 15, insetRight = 0, withSafeAreaView = Platform.OS === 'ios'
    ? parseInt(`${Platform.Version}`, 10) <= 10
        ? false
        : true
    : true, }) => {
    const localStyles = {
        separator: [styles.separator, { backgroundColor: backgroundColor }],
        separatorInner: [
            styles.separatorInner,
            {
                backgroundColor: isHidden ? 'transparent' : tintColor,
                marginLeft: insetLeft,
                marginRight: insetRight,
            },
        ],
    };
    if (withSafeAreaView) {
        return (<SafeAreaView style={localStyles.separator}>
        <View style={localStyles.separatorInner}/>
      </SafeAreaView>);
    }
    return (<View style={localStyles.separator}>
      <View style={localStyles.separatorInner}/>
    </View>);
};
const styles = StyleSheet.create({
    separator: {},
    separatorInner: {
        height: StyleSheet.hairlineWidth,
    },
});
export default Separator;
//# sourceMappingURL=Separator.js.map